package xyz.twokilohertz.mixin;

import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.ItemUsageContext;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;
import net.minecraft.world.World;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import xyz.twokilohertz.HotbarReplace;

@Mixin(ItemStack.class)
public class ItemStackMixin {
    Item lastUsedItem = null;

    @Inject(at = @At("HEAD"), method = "use")
    private void ItemStack_use_HEAD(World world, PlayerEntity player, Hand hand,
            CallbackInfoReturnable<ActionResult> info) {
        lastUsedItem = player.getStackInHand(hand).getItem();
    }

    @Inject(at = @At("HEAD"), method = "useOnBlock")
    private void ItemStack_useOnBlock_HEAD(ItemUsageContext context,
            CallbackInfoReturnable<ActionResult> info) {
        lastUsedItem = context.getPlayer().getStackInHand(context.getHand()).getItem();
    }

    @Inject(at = @At("HEAD"), method = "useOnEntity")
    private void ItemStack_useOnEntity_HEAD(PlayerEntity player, LivingEntity entity, Hand hand,
            CallbackInfoReturnable<ActionResult> info) {
        lastUsedItem = player.getStackInHand(hand).getItem();
    }

    @Inject(at = @At("TAIL"), method = "use")
    private void ItemStack_use_TAIL(World world, PlayerEntity player, Hand hand,
            CallbackInfoReturnable<ActionResult> info) {
        if (info.getReturnValue() != ActionResult.SUCCESS)
            return;

        if (player.getStackInHand(hand).getCount() != 0)
            return;

        HotbarReplace.tryReplaceSlot(player, hand, lastUsedItem);
    }

    @Inject(at = @At("TAIL"), method = "useOnBlock")
    private void ItemStack_useOnBlock_TAIL(ItemUsageContext context, CallbackInfoReturnable<ActionResult> info) {
        if (info.getReturnValue() != ActionResult.SUCCESS)
            return;

        PlayerEntity player = context.getPlayer();
        Hand hand = context.getHand();

        if (player.getStackInHand(hand).getCount() != 0)
            return;

        HotbarReplace.tryReplaceSlot(player, hand, lastUsedItem);
    }

    @Inject(at = @At("TAIL"), method = "useOnEntity")
    private void ItemStack_useOnEntity_TAIL(PlayerEntity player, LivingEntity entity, Hand hand,
            CallbackInfoReturnable<ActionResult> info) {
        if (info.getReturnValue() != ActionResult.SUCCESS)
            return;

        if (player.getStackInHand(hand).getCount() != 0)
            return;

        HotbarReplace.tryReplaceSlot(player, hand, lastUsedItem);
    }
}
